{
  
   Project  : ODGE
   Unit Name: uodge_quickpath

 /--------------------------------------------------------------\
 | Purpose    : QUICK PATH EDITOR                               |
 | Author     : Olivier DAHAN 100531.163@compuserve.com         |
 +--------------------------------------------------------------+
 | History    : V 1.0                                           |
 | Created on : 16/04/98 02:11:26                               |
 \--------------------------------------------------------------/
}

unit uodge_quickpath;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, BrowseDr;

type
  TFODGEQuickPath = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    SpeedButton6: TSpeedButton;
    bdd1: TBrowseDirectoryDlg;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Dclarations prives }
    fnew:boolean;
  public
    { Dclarations publiques }
  end;

var
  FODGEQuickPath: TFODGEQuickPath;

Procedure EditQuickPaths(List:TStrings);

implementation

{$R *.DFM}

Function Firstpart(const s:string):string;
var p:integer;
begin
 p := pos('=',s);
 if p>0 then result := copy(s,1,p-1) else result:='';
end;

Function Secondpart(const s:string):string;
var p:integer;
begin
 p:=pos('=',s);
 if p>0 then result := copy(s,p+1,length(s)) else result:='';
end;


Procedure EditQuickPaths(List:TStrings);
begin
 FODGEquickPath := TFODGEQuickPath.Create(application);
 try
  FODGEquickpath.Listbox1.items.assign(list);
  FODGEquickpath.Listbox1.Sorted := true;
  if FODGEquickpath.showmodal=mrok then List.assign(FODGEquickpath.listbox1.items);
 finally FODGEquickpath.release; end;
end;

procedure TFODGEQuickPath.SpeedButton1Click(Sender: TObject);
begin
edit1.enabled:=true;
edit2.enabled:=true;
SpeedButton4.visible := true;
SpeedButton5.visible:=true;
SpeedButton6.visible:=true;
SpeedButton1.enabled := false;
SpeedButton2.enabled := false;
SpeedButton3.enabled := false;
Listbox1.enabled:=false;
Edit1.SetFocus;
if Sender=Speedbutton1 then
 begin
  fnew:=true;
  Edit1.text:='';
  Edit2.text:='';
 end else
 begin
  fnew:=false;
  if Listbox1.itemindex<0 then Speedbutton5Click(SpeedButton5)
   else begin
         edit1.text := firstpart( listbox1.items[listbox1.itemindex] );
         edit2.text := secondpart( listbox1.items[listbox1.itemindex] );
        end;
 end;
end;

procedure TFODGEQuickPath.SpeedButton6Click(Sender: TObject);
begin
if bdd1.Execute then edit2.text := bdd1.Selection;
end;

procedure TFODGEQuickPath.SpeedButton5Click(Sender: TObject);
begin
edit1.enabled:=False;
edit2.enabled:=false;
listbox1.enabled:=true;
SpeedButton4.visible := false;
SpeedButton5.visible:=false;
SpeedButton6.visible:=False;
SpeedButton1.enabled := true;
SpeedButton2.enabled := true;
SpeedButton3.enabled := true;
if sender=speedbutton5 then
 begin
  if fnew then Listbox1.Items.add( trim(edit1.text)+'='+trim(edit2.text) )
          else Listbox1.Items[listbox1.Itemindex]:=trim(edit1.text)+'='+trim(edit2.text);
 end;
edit1.Text:='';
edit2.text:='';
Listbox1Click(nil);
Listbox1.setfocus;
end;

procedure TFODGEQuickPath.SpeedButton2Click(Sender: TObject);
begin
if listbox1.itemindex>-1 then
 begin
  listbox1.items.delete(listbox1.itemindex);
  edit1.text:='';
  edit2.text:='';
 end;
end;

procedure TFODGEQuickPath.ListBox1Click(Sender: TObject);
begin
if listbox1.itemindex>-1 then
 begin
  edit1.text := firstpart(Listbox1.Items[listbox1.itemindex]);
  edit2.text := secondpart(Listbox1.Items[listbox1.itemindex]);
 end else
 begin
  edit1.Text:='';
  edit2.text := '';
 end;
end;

end.

